
//-------------------------------------------------------------------------------//
// Author: Stefan Lörwald, Universität Heidelberg                                //
// License: CC BY-NC 4.0 http://creativecommons.org/licenses/by-nc/4.0/legalcode //
//-------------------------------------------------------------------------------//

#pragma once

#include "maps.h"
#include "matrix.h"
#include "row.h"
#include "tags.h"

namespace algorithm
{
   /// Returns all adjacent facets (or facet class representatives) of a
   /// facet by using the rotation algorithm.
   template <typename Integer>
   Facets<Integer> rotation(const Vertices<Integer>&, const Facet<Integer>&, const Maps&, FacetTag);
   /// Returns all adjacent vertices (or vertex class representatives) of a
   /// vertex by using the rotation algorithm.
   template <typename Integer>
   Vertices<Integer> rotation(const Inequalities<Integer>&, const Vertex<Integer>&, const Maps&, VertexTag);
}

#include "algorithm_rotation.eti"

