
//-------------------------------------------------------------------------------//
// Author: Stefan Lörwald, Universität Heidelberg                                //
// License: CC BY-NC 4.0 http://creativecommons.org/licenses/by-nc/4.0/legalcode //
//-------------------------------------------------------------------------------//

#define COMPILE_TEMPLATE_CAST
#include "cast.h"
#undef COMPILE_TEMPLATE_CAST

#include <cstddef>

template <typename Integer, typename OriginalType, is_different_t<Integer, OriginalType>>
Matrix<Integer> cast(const Matrix<OriginalType>& input)
{
   Matrix<Integer> output(input.size());
   for ( std::size_t i(0); i < output.size(); ++i )
   {
      output[i] = cast<Integer>(input[i]);
   }
   return output;
}

template <typename Integer, typename OriginalType, is_different_t<Integer, OriginalType>>
Row<Integer> cast(const Row<OriginalType>& input)
{
   Row<Integer> output;
   output.reserve(input.size());
   for ( std::size_t i(0); i < input.size(); ++i )
   {
      output.push_back(Integer(input[i]));
   }
   return output;
}

