
//-------------------------------------------------------------------------------//
// Author: Stefan Lörwald, Universität Heidelberg                                //
// License: CC BY-NC 4.0 http://creativecommons.org/licenses/by-nc/4.0/legalcode //
//-------------------------------------------------------------------------------//

#include "cast.h"

template <typename Integer>
std::tuple<Vertices<Integer>, Names, Maps, Inequalities<Integer>> input::vertices(int argc, char** argv)
{
   const auto data = vertices<int>(argc, argv);
   return std::make_tuple(cast<Integer>(std::get<0>(data)),  // vertices
                          std::get<1>(data),                 // names
                          std::get<2>(data),                 // maps
                          cast<Integer>(std::get<3>(data))); // inequalities
}

template <typename Integer>
std::tuple<Inequalities<Integer>, Names, Maps, Vertices<Integer>> input::inequalities(int argc, char** argv)
{
   const auto data = inequalities<int>(argc, argv);
   return std::make_tuple(cast<Integer>(std::get<0>(data)),  // inequalities
                          std::get<1>(data),                 // names
                          std::get<2>(data),                 // maps
                          cast<Integer>(std::get<3>(data))); // vertices
}

