
//-------------------------------------------------------------------------------//
// Author: Stefan Lörwald, Universität Heidelberg                                //
// License: CC BY-NC 4.0 http://creativecommons.org/licenses/by-nc/4.0/legalcode //
//-------------------------------------------------------------------------------//

#include "method_vertex_enumeration.h"

#include "input_method.h"
#include "method_adjacency_decomposition.h"
#include "method_double_description.h"

int method::vertexEnumeration(int argc, char** argv)
{
   const auto method = input::method(argc, argv);
   constexpr auto mode = OperationMode::VertexEnumeration;
   switch ( method )
   {
      case Method::AdjacencyDecomposition:
         return method::adjacencyDecomposition<mode>(argc, argv);
      case Method::DoubleDescription:
         return method::doubleDescription<mode>(argc, argv);
   }
   return 1;
}

